#include <stdio.h>

#include "Serial.h"

static serialCL serial;
static const int MMAX_INT = 0xffffffff;

void printHEX(unsigned char v) {
	if (v<0x10 && v>=0) printf("0%1x ",v);
	else printf("%x ", v);
}

#define RESET_ALL	0x00
#define READ_01		0x01
#define READ_0		0x02
#define READ_1		0x03

int main(){
	unsigned char buf[256];
	unsigned long l=2;
	signed int result;
	int r0, r1;

	result=serial.open("COM1", 9600); 
	if(result!=SERIAL_SUCCESS){
		printf("Cannot open serial, it may be used by another application");
		return -1;
	}
	else printf("Init OK\n");

	buf[0]=RESET_ALL; // reset all
	serial.write(buf, 1);
	
	printf("Reset All Done\n");
	while(1) {

		buf[0]=READ_0;
		serial.write(buf, 1);

		if (buf[0]==READ_01) l=8;
		else l=4;
		serial.forceRead(buf+1, l);
		if (buf[0]!=READ_1) 
			r0=(buf[4]<<24) + (buf[3]<<16) + (buf[2]<<8) + buf[1];
		else
			r0=0;
		if (buf[0]!=READ_0) 
			r1=(buf[8]<<24) + (buf[7]<<16) + (buf[6]<<8) + buf[5];
		else
			r1=0;

		if (buf[0]==READ_0) 
			printf(" %d          %c",r0, (unsigned char)13);
		else if (buf[0]==READ_1) 
			printf(" %d          %c",r0, (unsigned char)13);
		else
			printf(" %d  \t %d          %c",r0, r1, (unsigned char)13);

	}
	return 1;
}